#include <sys/sem.h>
#include <sys/stat.h>

#include <custom_sem.h>
#include <structures.h>
#include <errExit.h>

void semOp(int semid, short sem_num, short sem_op) {
    struct sembuf sop = {.sem_num = sem_num, .sem_op = sem_op, .sem_flg = 0};

    if (semop(semid, &sop, 1) == -1) {
        errExit("semop", "semOp");
    }
}

int getSemid(key_t key, int size){
    int semid = semget(key, size, S_IRUSR | S_IWUSR | IPC_CREAT);
    if (semid == -1) {
        errExit("semget", "getSemid");
    }

    return semid;
}

// mette i semafori a 0 e 2
void resetServerSem(int semid){
    unsigned short val[2] = {0, 2};
    union semun arg;
    arg.array = val;

    if (semctl(semid, 0 , SETALL, arg) == -1) {
        errExit("semctl", "getSemid");
    }
}