#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <server.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/stat.h>

#include <errExit.h>

input_server_t check_input(int argc, char *argv[]){
    if (argc < 5) {
        printf("\033[92m<Help>\033[39m ./F4Server ROW COL PLAYER1 PLAYER2\n"
               "\t- ROW \t\tnumber of rows\n"
               "\t- COL \t\tnumber of rows\n"
               "\t- PLAYER1 \tplayer one token\n"
               "\t- PLAYER2 \tplayer two token\n"
               );
        exit(EXIT_SUCCESS);
    } else if (argc > 5) {
        errExitMsg("To many arguments");
    }

    input_server_t input = {
        .collums = atoi(argv[1]),
        .rows = atoi(argv[2]),
        .player1Token = argv[3][0],
        .player2Token = argv[4][0]
    };

    if (input.collums<5 || input.rows<5) {
        errExitMsg("To few rows or collums");
    }

    if (!isprint(input.player1Token) || !isprint(input.player2Token)) {
        errExitMsg("Invalid player token");
    }

    return input;
}